#!/usr/bin/env python

from os     import environ
from sys    import argv, exit
from socket import socket, AF_UNIX, SOCK_STREAM
from mpdlib import mpd_set_my_id, mpd_send_one_msg, mpd_recv_one_msg, mpd_raise, mpdError

def mpdkilljob():
    mpd_set_my_id('mpdkilljob_')
    if len(argv) < 2  or  argv[1] == '-h'  or  argv[1] == '--help':
        print 'usage: mpdkilljob  jobnum  [mpdid]  # as obtained from mpdlistjobs'
        print '    mpdid is mpd contacted by mpdrun to start the job (defaults to here)'
        exit(-1)
    consoleName = '/tmp/mpd2.console_' + environ['USER']
    conSocket = socket(AF_UNIX, SOCK_STREAM)             # note: UNIX socket
    try:
	conSocket.connect(consoleName)
    except Exception, errmsg:
        mpd_raise('cannot connect to local mpd')
        # mpd_raise('cannot connect to local mpd; errmsg: %s' % (str(errmsg)) )
    jobnum = argv[1]
    if len(argv) > 2:
        mpdid = argv[2]
    else:
        mpdid = ''
    mpd_send_one_msg(conSocket, {'cmd':'mpdkilljob', 'jobnum' : jobnum, 'mpdid' : mpdid})
    msg = mpd_recv_one_msg(conSocket)
    if not msg or msg['cmd'] != 'mpdkilljob_ack':
        if msg['cmd'] == 'already_have_a_console':
            mpd_raise('mpd already has a console (e.g. for long ringtest); try later')
        else:
            mpd_raise('unexpected message from mpd: %s' % (msg) )
    conSocket.close()

if __name__ == '__main__':
    try:
	mpdkilljob()
    except mpdError, errmsg:
	print 'mpdkilljob failed: %s' % (errmsg)
