#!/usr/bin/env python

from sys    import argv, exit
from os     import environ
from socket import socket, AF_UNIX, SOCK_STREAM
from re     import sub
from mpdlib import mpd_set_my_id, mpd_send_one_msg, mpd_recv_one_msg, mpd_raise, mpdError

def mpdlistjobs():
    mpd_set_my_id('mpdlistjobs_')
    if len(argv) > 1  and  ( argv[1] == '-h'  or  argv[1] == '--help' ) :
        print 'usage: mpdlistjobs (no args)'
        exit(-1)
    consoleName = '/tmp/mpd2.console_' + environ['USER']
    conSocket = socket(AF_UNIX,SOCK_STREAM)  # note: UNIX socket
    try:
	conSocket.connect(consoleName)
    except Exception, errmsg:
        mpd_raise('cannot connect to local mpd')
    msgToSend = { 'cmd' : 'mpdlistjobs' }
    mpd_send_one_msg(conSocket,msgToSend)
    printed_hdr = 0
    while 1:
        msg = mpd_recv_one_msg(conSocket)
        if (not msg.has_key('cmd')):
            raise RuntimeError, 'mpdlistjobs: INVALID msg=:%s:' % (msg)
        if (msg['cmd'] == 'mpdlistjobs_info'):
            if not printed_hdr:
                hdr = 'jobid'  +  ' ' * (len(msg['jobid'])-1)  +  \
		      'host'  +  ' ' * (len(msg['host']))  +  \
		      'rank    user        pgm'
                print hdr + '\n' + '-' * len(hdr)
                printed_hdr = 1
            print '%s    %s    %s       %s     %s' % \
                  (msg['jobid'],msg['host'],msg['rank'],msg['username'],msg['pgm'])
        else:
            break  # mpdlistjobs_trailer


if __name__ == '__main__':
    try:
        mpdlistjobs()
    except mpdError, errmsg:
	print 'mpdlistjobs failed: %s' % (errmsg)
