#!/usr/bin/env python

from os     import environ
from sys    import argv, exit
from socket import socket, AF_UNIX, SOCK_STREAM
from mpdlib import mpd_set_my_id, mpd_send_one_msg, mpd_recv_one_msg, mpd_raise, mpdError

def mpdsigjob():
    mpd_set_my_id('mpdsigjob_')
    if len(argv) < 2  or  argv[1] == '-h'  or  argv[1] == '--help':
        print 'usage: mpdsigjob  sigtype  jobnum  [mpdid]  # as obtained from mpdlistjobs'
        print '    mpdid is mpd contacted by mpdrun to start the job (defaults to here)'
        exit(-1)
    consoleName = '/tmp/mpd2.console_' + environ['USER']
    conSocket = socket(AF_UNIX, SOCK_STREAM)             # note: UNIX socket
    try:
	conSocket.connect(consoleName)
    except Exception, errmsg:
        mpd_raise('cannot connect to local mpd')
        # mpd_raise('cannot connect to local mpd; errmsg: %s' % (str(errmsg)) )
    sigtype = argv[1]
    jobnum = argv[2]
    if len(argv) > 3:
        mpdid = argv[3]
    else:
        mpdid = ''
    mpd_send_one_msg(conSocket, {'cmd' : 'mpdsigjob', 'sigtype': sigtype,
                                 'jobnum' : jobnum, 'mpdid' : mpdid})
    msg = mpd_recv_one_msg(conSocket)
    if not msg or msg['cmd'] != 'mpdsigjob_ack':
        if msg['cmd'] == 'already_have_a_console':
            mpd_raise('mpd already has a console (e.g. for long ringtest); try later')
        else:
            mpd_raise('unexpected message from mpd: %s' % (msg) )
    conSocket.close()

if __name__ == '__main__':
    try:
	mpdsigjob()
    except mpdError, errmsg:
	print 'mpdsigjob failed: %s' % (errmsg)
